pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT > Class Template Reference
Module registration

Pose estimation and alignment class using a prerejective RANSAC routine. More...

`#include <pcl/registration/sample_consensus_prerejective.h>`

Inheritance diagram for pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >:

## Public Types

typedef Registration< PointSource, PointTarget >::Matrix4 | Matrix4
typedef Registration< PointSource, PointTarget >::PointCloudSource | PointCloudSource
typedef PointCloudSource::Ptr | PointCloudSourcePtr
typedef PointCloudSource::ConstPtr | PointCloudSourceConstPtr
typedef Registration< PointSource, PointTarget >::PointCloudTarget | PointCloudTarget
typedef PointIndices::Ptr | PointIndicesPtr
typedef PointIndices::ConstPtr | PointIndicesConstPtr
typedef pcl::PointCloud< FeatureT > | FeatureCloud
typedef FeatureCloud::Ptr | FeatureCloudPtr
typedef FeatureCloud::ConstPtr | FeatureCloudConstPtr
typedef boost::shared_ptr< SampleConsensusPrerejective< PointSource, PointTarget, FeatureT > > | Ptr
typedef boost::shared_ptr< const SampleConsensusPrerejective< PointSource, PointTarget, FeatureT > > | ConstPtr
typedef KdTreeFLANN< FeatureT >::Ptr | FeatureKdTreePtr
typedef pcl::registration::CorrespondenceRejectorPoly< PointSource, PointTarget > | CorrespondenceRejectorPoly
typedef CorrespondenceRejectorPoly::Ptr | CorrespondenceRejectorPolyPtr
typedef CorrespondenceRejectorPoly::ConstPtr | CorrespondenceRejectorPolyConstPtr
Public Types inherited from pcl::Registration< PointSource, PointTarget >
typedef Eigen::Matrix< float, 4, 4 > | Matrix4
typedef boost::shared_ptr< Registration< PointSource, PointTarget, float > > | Ptr
typedef boost::shared_ptr< const Registration< PointSource, PointTarget, float > > | ConstPtr
typedef pcl::registration::CorrespondenceRejector::Ptr | CorrespondenceRejectorPtr
typedef pcl::search::KdTree< PointTarget > | KdTree
typedef pcl::search::KdTree< PointTarget >::Ptr | KdTreePtr
typedef pcl::search::KdTree< PointSource > | KdTreeReciprocal
typedef KdTreeReciprocal::Ptr | KdTreeReciprocalPtr
typedef pcl::PointCloud< PointSource > | PointCloudSource
typedef PointCloudSource::Ptr | PointCloudSourcePtr
typedef PointCloudSource::ConstPtr | PointCloudSourceConstPtr
typedef pcl::PointCloud< PointTarget > | PointCloudTarget
typedef PointCloudTarget::Ptr | PointCloudTargetPtr
typedef PointCloudTarget::ConstPtr | PointCloudTargetConstPtr
typedef KdTree::PointRepresentationConstPtr | PointRepresentationConstPtr
typedef pcl::registration::TransformationEstimation< PointSource, PointTarget, float > | TransformationEstimation
typedef TransformationEstimation::Ptr | TransformationEstimationPtr
typedef TransformationEstimation::ConstPtr | TransformationEstimationConstPtr
typedef pcl::registration::CorrespondenceEstimationBase< PointSource, PointTarget, float > | CorrespondenceEstimation
typedef CorrespondenceEstimation::Ptr | CorrespondenceEstimationPtr
typedef CorrespondenceEstimation::ConstPtr | CorrespondenceEstimationConstPtr
Public Types inherited from pcl::PCLBase< PointSource >
typedef pcl::PointCloud< PointSource > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| SampleConsensusPrerejective ()
| Constructor. More...
virtual | ~SampleConsensusPrerejective ()
| Destructor. More...
void | setSourceFeatures (const FeatureCloudConstPtr &features)
| Provide a boost shared pointer to the source point cloud's feature descriptors. More...
const FeatureCloudConstPtr | getSourceFeatures () const
| Get a pointer to the source point cloud's features. More...
void | setTargetFeatures (const FeatureCloudConstPtr &features)
| Provide a boost shared pointer to the target point cloud's feature descriptors. More...
const FeatureCloudConstPtr | getTargetFeatures () const
| Get a pointer to the target point cloud's features. More...
void | setNumberOfSamples (int nr_samples)
| Set the number of samples to use during each iteration. More...
int | getNumberOfSamples () const
| Get the number of samples to use during each iteration, as set by the user. More...
void | setCorrespondenceRandomness (int k)
| Set the number of neighbors to use when selecting a random feature correspondence. More...
int | getCorrespondenceRandomness () const
| Get the number of neighbors used when selecting a random feature correspondence, as set by the user. More...
void | setSimilarityThreshold (float similarity_threshold)
| Set the similarity threshold in [0,1[ between edge lengths of the underlying polygonal correspondence rejector object, where 1 is a perfect match. More...
float | getSimilarityThreshold () const
| Get the similarity threshold between edge lengths of the underlying polygonal correspondence rejector object,. More...
void | setInlierFraction (float inlier_fraction)
| Set the required inlier fraction (of the input) More...
float | getInlierFraction () const
| Get the required inlier fraction. More...
const std::vector< int > & | getInliers () const
| Get the inlier indices of the source point cloud under the final transformation. More...
Public Member Functions inherited from pcl::Registration< PointSource, PointTarget >
| Registration ()
| Empty constructor. More...
virtual | ~Registration ()
| destructor. More...
void | setTransformationEstimation (const TransformationEstimationPtr &te)
| Provide a pointer to the transformation estimation object. More...
void | setCorrespondenceEstimation (const CorrespondenceEstimationPtr &ce)
| Provide a pointer to the correspondence estimation object. More...
void | setInputCloud (const PointCloudSourceConstPtr &cloud)
| Provide a pointer to the input source (e.g., the point cloud that we want to align to the target) More...
PointCloudSourceConstPtr const | getInputCloud ()
| Get a pointer to the input point cloud dataset target. More...
virtual void | setInputSource (const PointCloudSourceConstPtr &cloud)
| Provide a pointer to the input source (e.g., the point cloud that we want to align to the target) More...
PointCloudSourceConstPtr const | getInputSource ()
| Get a pointer to the input point cloud dataset target. More...
virtual void | setInputTarget (const PointCloudTargetConstPtr &cloud)
| Provide a pointer to the input target (e.g., the point cloud that we want to align the input source to) More...
PointCloudTargetConstPtr const | getInputTarget ()
| Get a pointer to the input point cloud dataset target. More...
void | setSearchMethodTarget (const KdTreePtr &tree, bool force_no_recompute=false)
| Provide a pointer to the search object used to find correspondences in the target cloud. More...
KdTreePtr | getSearchMethodTarget () const
| Get a pointer to the search method used to find correspondences in the target cloud. More...
void | setSearchMethodSource (const KdTreeReciprocalPtr &tree, bool force_no_recompute=false)
| Provide a pointer to the search object used to find correspondences in the source cloud (usually used by reciprocal correspondence finding). More...
KdTreeReciprocalPtr | getSearchMethodSource () const
| Get a pointer to the search method used to find correspondences in the source cloud. More...
Matrix4 | getFinalTransformation ()
| Get the final transformation matrix estimated by the registration method. More...
Matrix4 | getLastIncrementalTransformation ()
| Get the last incremental transformation matrix estimated by the registration method. More...
void | setMaximumIterations (int nr_iterations)
| Set the maximum number of iterations the internal optimization should run for. More...
int | getMaximumIterations ()
| Get the maximum number of iterations the internal optimization should run for, as set by the user. More...
void | setRANSACIterations (int ransac_iterations)
| Set the number of iterations RANSAC should run for. More...
double | getRANSACIterations ()
| Get the number of iterations RANSAC should run for, as set by the user. More...
void | setRANSACOutlierRejectionThreshold (double inlier_threshold)
| Set the inlier distance threshold for the internal RANSAC outlier rejection loop. More...
double | getRANSACOutlierRejectionThreshold ()
| Get the inlier distance threshold for the internal outlier rejection loop as set by the user. More...
void | setMaxCorrespondenceDistance (double distance_threshold)
| Set the maximum distance threshold between two correspondent points in source <-> target. More...
double | getMaxCorrespondenceDistance ()
| Get the maximum distance threshold between two correspondent points in source <-> target. More...
void | setTransformationEpsilon (double epsilon)
| Set the transformation epsilon (maximum allowable difference between two consecutive transformations) in order for an optimization to be considered as having converged to the final solution. More...
double | getTransformationEpsilon ()
| Get the transformation epsilon (maximum allowable difference between two consecutive transformations) as set by the user. More...
void | setEuclideanFitnessEpsilon (double epsilon)
| Set the maximum allowed Euclidean error between two consecutive steps in the ICP loop, before the algorithm is considered to have converged. More...
double | getEuclideanFitnessEpsilon ()
| Get the maximum allowed distance error before the algorithm will be considered to have converged, as set by the user. More...
void | setPointRepresentation (const PointRepresentationConstPtr &point_representation)
| Provide a boost shared pointer to the PointRepresentation to be used when comparing points. More...
bool | registerVisualizationCallback (boost::function< FunctionSignature > &visualizerCallback)
| Register the user callback function which will be called from registration thread in order to update point cloud obtained after each iteration. More...
double | getFitnessScore (double max_range=std::numeric_limits< double >::max())
| Obtain the Euclidean fitness score (e.g., sum of squared distances from the source to the target) More...
double | getFitnessScore (const std::vector< float > &distances_a, const std::vector< float > &distances_b)
| Obtain the Euclidean fitness score (e.g., sum of squared distances from the source to the target) from two sets of correspondence distances (distances between source and target points) More...
bool | hasConverged ()
| Return the state of convergence after the last align run. More...
void | align (PointCloudSource &output)
| Call the registration algorithm which estimates the transformation and returns the transformed source (input) as output. More...
void | align (PointCloudSource &output, const Matrix4 &guess)
| Call the registration algorithm which estimates the transformation and returns the transformed source (input) as output. More...
const std::string & | getClassName () const
| Abstract class get name method. More...
bool | initCompute ()
| Internal computation initalization. More...
bool | initComputeReciprocal ()
| Internal computation when reciprocal lookup is needed. More...
void | addCorrespondenceRejector (const CorrespondenceRejectorPtr &rejector)
| Add a new correspondence rejector to the list. More...
std::vector< CorrespondenceRejectorPtr > | getCorrespondenceRejectors ()
| Get the list of correspondence rejectors. More...
bool | removeCorrespondenceRejector (unsigned int i)
| Remove the i-th correspondence rejector in the list. More...
void | clearCorrespondenceRejectors ()
| Clear the list of correspondence rejectors. More...
Public Member Functions inherited from pcl::PCLBase< PointSource >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointSource & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

int | getRandomIndex (int n) const
| Choose a random index between 0 and n-1. More...
void | selectSamples (const PointCloudSource &cloud, int nr_samples, std::vector< int > &sample_indices)
| Select nr_samples sample points from cloud while making sure that their pairwise distances are greater than a user-defined minimum distance, min_sample_distance. More...
void | findSimilarFeatures (const std::vector< int > &sample_indices, std::vector< std::vector< int > > &similar_features, std::vector< int > &corresponding_indices)
| For each of the sample points, find a list of points in the target cloud whose features are similar to the sample points' features. More...
void | computeTransformation (PointCloudSource &output, const Eigen::Matrix4f &guess)
| Rigid transformation computation method. More...
void | getFitness (std::vector< int > &inliers, float &fitness_score)
| Obtain the fitness of a transformation The following metrics are calculated, based on final_transformation_ and corr_dist_threshold_: More...
Protected Member Functions inherited from pcl::Registration< PointSource, PointTarget >
bool | searchForNeighbors (const PointCloudSource &cloud, int index, std::vector< int > &indices, std::vector< float > &distances)
| Search for the closest nearest neighbor of a given point. More...
virtual void | computeTransformation (PointCloudSource &output, const Matrix4 &guess)=0
| Abstract transformation computation method with initial guess. More...
Protected Member Functions inherited from pcl::PCLBase< PointSource >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Protected Attributes

FeatureCloudConstPtr | input_features_
| The source point cloud's feature descriptors. More...
FeatureCloudConstPtr | target_features_
| The target point cloud's feature descriptors. More...
int | nr_samples_
| The number of samples to use during each iteration. More...
int | k_correspondences_
| The number of neighbors to use when selecting a random feature correspondence. More...
FeatureKdTreePtr | feature_tree_
| The KdTree used to compare feature descriptors. More...
CorrespondenceRejectorPolyPtr | correspondence_rejector_poly_
| The polygonal correspondence rejector used for prerejection. More...
float | inlier_fraction_
| The fraction [0,1] of inlier points required for accepting a transformation. More...
std::vector< int > | inliers_
| Inlier points of final transformation as indices into source. More...
Protected Attributes inherited from pcl::Registration< PointSource, PointTarget >
std::string | reg_name_
| The registration method name. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
KdTreeReciprocalPtr | tree_reciprocal_
| A pointer to the spatial search object of the source. More...
int | nr_iterations_
| The number of iterations the internal optimization ran for (used internally). More...
int | max_iterations_
| The maximum number of iterations the internal optimization should run for. More...
int | ransac_iterations_
| The number of iterations RANSAC should run for. More...
PointCloudTargetConstPtr | target_
| The input point cloud dataset target. More...
Matrix4 | final_transformation_
| The final transformation matrix estimated by the registration method after N iterations. More...
Matrix4 | transformation_
| The transformation matrix estimated by the registration method. More...
Matrix4 | previous_transformation_
| The previous transformation matrix estimated by the registration method (used internally). More...
double | transformation_epsilon_
| The maximum difference between two consecutive transformations in order to consider convergence (user defined). More...
double | euclidean_fitness_epsilon_
| The maximum allowed Euclidean error between two consecutive steps in the ICP loop, before the algorithm is considered to have converged. More...
double | corr_dist_threshold_
| The maximum distance threshold between two correspondent points in source <-> target. More...
double | inlier_threshold_
| The inlier distance threshold for the internal RANSAC outlier rejection loop. More...
bool | converged_
| Holds internal convergence state, given user parameters. More...
int | min_number_correspondences_
| The minimum number of correspondences that the algorithm needs before attempting to estimate the transformation. More...
CorrespondencesPtr | correspondences_
| The set of correspondences determined at this ICP step. More...
TransformationEstimationPtr | transformation_estimation_
| A TransformationEstimation object, used to calculate the 4x4 rigid transformation. More...
CorrespondenceEstimationPtr | correspondence_estimation_
| A CorrespondenceEstimation object, used to estimate correspondences between the source and the target cloud. More...
std::vector< CorrespondenceRejectorPtr > | correspondence_rejectors_
| The list of correspondence rejectors to use. More...
bool | target_cloud_updated_
| Variable that stores whether we have a new target cloud, meaning we need to pre-process it again. More...
bool | source_cloud_updated_
| Variable that stores whether we have a new source cloud, meaning we need to pre-process it again. More...
bool | force_no_recompute_
| A flag which, if set, means the tree operating on the target cloud will never be recomputed. More...
bool | force_no_recompute_reciprocal_
| A flag which, if set, means the tree operating on the source cloud will never be recomputed. More...
boost::function< void(const pcl::PointCloud< PointSource > &cloud_src, const std::vector< int > &indices_src, const pcl::PointCloud< PointTarget > &cloud_tgt, const std::vector< int > &indices_tgt)> | update_visualizer_
| Callback function to update intermediate source point cloud position during it's registration to the target point cloud. More...
Protected Attributes inherited from pcl::PCLBase< PointSource >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointSource, typename PointTarget, typename FeatureT>
class pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >

Pose estimation and alignment class using a prerejective RANSAC routine.

This class inserts a simple, yet effective "prerejection" step into the standard RANSAC pose estimation loop in order to avoid verification of pose hypotheses that are likely to be wrong. This is achieved by local pose-invariant geometric constraints, as also implemented in the class CorrespondenceRejectorPoly.

In order to robustly align partial/occluded models, this routine performs fit error evaluation using only inliers, i.e. points closer than a Euclidean threshold, which is specifiable using setInlierFraction().

The amount of prerejection or "greedyness" of the algorithm can be specified using setSimilarityThreshold() in [0,1[, where a value of 0 means disabled, and 1 is maximally rejective.

If you use this in academic work, please cite:

A. G. Buch, D. Kraft, J.-K. Kämäräinen, H. G. Petersen and N. Krüger. Pose Estimation using Local Structure-Specific Shape and Appearance Context. International Conference on Robotics and Automation (ICRA), 2013.

Author
  Anders Glent Buch (ander.nosp@m.sgb1.nosp@m.@gmai.nosp@m.l.co.nosp@m.m)

Definition at line 77 of file sample_consensus_prerejective.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointSource , typename PointTarget , typename FeatureT >

typedef boost::shared_ptr<const SampleConsensusPrerejective<PointSource, PointTarget, FeatureT> > pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::ConstPtr

Definition at line 109 of file sample_consensus_prerejective.h.

## CorrespondenceRejectorPoly

template<typename PointSource , typename PointTarget , typename FeatureT >

typedef pcl::registration::CorrespondenceRejectorPoly<PointSource, PointTarget> pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::CorrespondenceRejectorPoly

Definition at line 113 of file sample_consensus_prerejective.h.

## CorrespondenceRejectorPolyConstPtr

template<typename PointSource , typename PointTarget , typename FeatureT >

typedef CorrespondenceRejectorPoly::ConstPtr pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::CorrespondenceRejectorPolyConstPtr

Definition at line 115 of file sample_consensus_prerejective.h.

## CorrespondenceRejectorPolyPtr

template<typename PointSource , typename PointTarget , typename FeatureT >

typedef CorrespondenceRejectorPoly::Ptr pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::CorrespondenceRejectorPolyPtr

Definition at line 114 of file sample_consensus_prerejective.h.

## FeatureCloud

template<typename PointSource , typename PointTarget , typename FeatureT >

typedef pcl::PointCloud<FeatureT> pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::FeatureCloud

Definition at line 104 of file sample_consensus_prerejective.h.

## FeatureCloudConstPtr

template<typename PointSource , typename PointTarget , typename FeatureT >

typedef FeatureCloud::ConstPtr pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::FeatureCloudConstPtr

Definition at line 106 of file sample_consensus_prerejective.h.

## FeatureCloudPtr

template<typename PointSource , typename PointTarget , typename FeatureT >

typedef FeatureCloud::Ptr pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::FeatureCloudPtr

Definition at line 105 of file sample_consensus_prerejective.h.

## FeatureKdTreePtr

template<typename PointSource , typename PointTarget , typename FeatureT >

typedef KdTreeFLANN<FeatureT>::Ptr pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::FeatureKdTreePtr

Definition at line 111 of file sample_consensus_prerejective.h.

## Matrix4

template<typename PointSource , typename PointTarget , typename FeatureT >

typedef Registration<PointSource, PointTarget>::Matrix4 pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::Matrix4

Definition at line 80 of file sample_consensus_prerejective.h.

## PointCloudSource

template<typename PointSource , typename PointTarget , typename FeatureT >

typedef Registration<PointSource, PointTarget>::PointCloudSource pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::PointCloudSource

Definition at line 95 of file sample_consensus_prerejective.h.

## PointCloudSourceConstPtr

template<typename PointSource , typename PointTarget , typename FeatureT >

typedef PointCloudSource::ConstPtr pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::PointCloudSourceConstPtr

Definition at line 97 of file sample_consensus_prerejective.h.

## PointCloudSourcePtr

template<typename PointSource , typename PointTarget , typename FeatureT >

typedef PointCloudSource::Ptr pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::PointCloudSourcePtr

Definition at line 96 of file sample_consensus_prerejective.h.

## PointCloudTarget

template<typename PointSource , typename PointTarget , typename FeatureT >

typedef Registration<PointSource, PointTarget>::PointCloudTarget pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::PointCloudTarget

Definition at line 99 of file sample_consensus_prerejective.h.

## PointIndicesConstPtr

template<typename PointSource , typename PointTarget , typename FeatureT >

typedef PointIndices::ConstPtr pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::PointIndicesConstPtr

Definition at line 102 of file sample_consensus_prerejective.h.

## PointIndicesPtr

template<typename PointSource , typename PointTarget , typename FeatureT >

typedef PointIndices::Ptr pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::PointIndicesPtr

Definition at line 101 of file sample_consensus_prerejective.h.

## Ptr

template<typename PointSource , typename PointTarget , typename FeatureT >

typedef boost::shared_ptr<SampleConsensusPrerejective<PointSource, PointTarget, FeatureT> > pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::Ptr

Definition at line 108 of file sample_consensus_prerejective.h.

## Constructor & Destructor Documentation

## SampleConsensusPrerejective()

template<typename PointSource , typename PointTarget , typename FeatureT >

pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::SampleConsensusPrerejective | ( |  | ) |

inline

Constructor.

Definition at line 118 of file sample_consensus_prerejective.h.

References pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::correspondence_rejector_poly_, pcl::Registration< PointSource, PointTarget >::max_iterations_, pcl::Registration< PointSource, PointTarget >::reg_name_, and pcl::Registration< PointSource, PointTarget >::transformation_estimation_.

## ~SampleConsensusPrerejective()

template<typename PointSource , typename PointTarget , typename FeatureT >

virtual pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::~SampleConsensusPrerejective | ( |  | ) |

inline virtual

Destructor.

Definition at line 134 of file sample_consensus_prerejective.h.

References pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::setSourceFeatures().

## Member Function Documentation

## computeTransformation()

template<typename PointSource , typename PointTarget , typename FeatureT >

void pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::computeTransformation | ( | PointCloudSource & | output,
|  | const Eigen::Matrix4f & | guess
| ) |  |

protected

Rigid transformation computation method.

Parameters

  output | the transformed input point cloud dataset using the rigid transformation found
  guess | The computed transformation

Definition at line 144 of file sample_consensus_prerejective.hpp.

References pcl::transformPointCloud().

Referenced by pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getRandomIndex().

## findSimilarFeatures()

template<typename PointSource , typename PointTarget , typename FeatureT >

void pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::findSimilarFeatures | ( | const std::vector< int > & | sample_indices,
|  | std::vector< std::vector< int > > & | similar_features,
|  | std::vector< int > & | corresponding_indices
| ) |  |

protected

For each of the sample points, find a list of points in the target cloud whose features are similar to the sample points' features.

From these, select one randomly which will be considered that sample point's correspondence.

Parameters

  sample_indices | the indices of each sample point
  similar_features | correspondence cache, which is used to read/write already computed correspondences
  corresponding_indices | the resulting indices of each sample's corresponding point in the target cloud

Definition at line 115 of file sample_consensus_prerejective.hpp.

Referenced by pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getRandomIndex().

## getCorrespondenceRandomness()

template<typename PointSource , typename PointTarget , typename FeatureT >

int pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getCorrespondenceRandomness | ( |  | ) | const

inline

Get the number of neighbors used when selecting a random feature correspondence, as set by the user.

Definition at line 192 of file sample_consensus_prerejective.h.

References pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::k_correspondences_.

## getFitness()

template<typename PointSource , typename PointTarget , typename FeatureT >

void pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getFitness | ( | std::vector< int > & | inliers,
|  | float & | fitness_score
| ) |  |

protected

Obtain the fitness of a transformation The following metrics are calculated, based on final_transformation_ and corr_dist_threshold_:

- Inliers: the number of transformed points which are closer than threshold to NN
- Error score: the MSE of the inliers
  Parameters

    inliers | indices of source point cloud inliers
    fitness_score | output fitness score as RMSE

Definition at line 294 of file sample_consensus_prerejective.hpp.

References pcl::transformPointCloud().

Referenced by pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getRandomIndex().

## getInlierFraction()

template<typename PointSource , typename PointTarget , typename FeatureT >

float pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getInlierFraction | ( |  | ) | const

inline

Get the required inlier fraction.

Returns
  required inlier fraction in [0,1]

Definition at line 229 of file sample_consensus_prerejective.h.

References pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::inlier_fraction_.

## getInliers()

template<typename PointSource , typename PointTarget , typename FeatureT >

const std::vector<int>& pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getInliers | ( |  | ) | const

inline

Get the inlier indices of the source point cloud under the final transformation.

Returns
  inlier indices

Definition at line 238 of file sample_consensus_prerejective.h.

References pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::inliers_.

## getNumberOfSamples()

template<typename PointSource , typename PointTarget , typename FeatureT >

int pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getNumberOfSamples | ( |  | ) | const

inline

Get the number of samples to use during each iteration, as set by the user.

Definition at line 175 of file sample_consensus_prerejective.h.

References pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::nr_samples_.

## getRandomIndex()

template<typename PointSource , typename PointTarget , typename FeatureT >

int pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getRandomIndex | ( | int | n | ) | const

inline protected

Choose a random index between 0 and n-1.

Parameters

  n | the number of possible indices to choose from

Definition at line 248 of file sample_consensus_prerejective.h.

References pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::computeTransformation(), pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::findSimilarFeatures(), pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getFitness(), and pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::selectSamples().

## getSimilarityThreshold()

template<typename PointSource , typename PointTarget , typename FeatureT >

float pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getSimilarityThreshold | ( |  | ) | const

inline

Get the similarity threshold between edge lengths of the underlying polygonal correspondence rejector object,.

Returns
  edge length similarity threshold

Definition at line 211 of file sample_consensus_prerejective.h.

References pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::correspondence_rejector_poly_.

## getSourceFeatures()

template<typename PointSource , typename PointTarget , typename FeatureT >

const FeatureCloudConstPtr pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getSourceFeatures | ( |  | ) | const

inline

Get a pointer to the source point cloud's features.

Definition at line 146 of file sample_consensus_prerejective.h.

References pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::input_features_, and pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::setTargetFeatures().

## getTargetFeatures()

template<typename PointSource , typename PointTarget , typename FeatureT >

const FeatureCloudConstPtr pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getTargetFeatures | ( |  | ) | const

inline

Get a pointer to the target point cloud's features.

Definition at line 159 of file sample_consensus_prerejective.h.

References pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::target_features_.

## selectSamples()

template<typename PointSource , typename PointTarget , typename FeatureT >

void pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::selectSamples | ( | const PointCloudSource & | cloud,
|  | int | nr_samples,
|  | std::vector< int > & | sample_indices
| ) |  |

protected

Select nr_samples sample points from cloud while making sure that their pairwise distances are greater than a user-defined minimum distance, min_sample_distance.

Parameters

  cloud | the input point cloud
  nr_samples | the number of samples to select
  sample_indices | the resulting sample indices

Definition at line 71 of file sample_consensus_prerejective.hpp.

Referenced by pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getRandomIndex().

## setCorrespondenceRandomness()

template<typename PointSource , typename PointTarget , typename FeatureT >

void pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::setCorrespondenceRandomness | ( | int | k | ) |

inline

Set the number of neighbors to use when selecting a random feature correspondence.

A higher value will add more randomness to the feature matching.

Parameters

  k | the number of neighbors to use when selecting a random feature correspondence.

Definition at line 185 of file sample_consensus_prerejective.h.

References pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::k_correspondences_.

## setInlierFraction()

template<typename PointSource , typename PointTarget , typename FeatureT >

void pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::setInlierFraction | ( | float | inlier_fraction | ) |

inline

Set the required inlier fraction (of the input)

Parameters

  inlier_fraction | required inlier fraction, must be in [0,1]

Definition at line 220 of file sample_consensus_prerejective.h.

References pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::inlier_fraction_.

## setNumberOfSamples()

template<typename PointSource , typename PointTarget , typename FeatureT >

void pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::setNumberOfSamples | ( | int | nr_samples | ) |

inline

Set the number of samples to use during each iteration.

Parameters

  nr_samples | the number of samples to use during each iteration

Definition at line 168 of file sample_consensus_prerejective.h.

References pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::nr_samples_.

## setSimilarityThreshold()

template<typename PointSource , typename PointTarget , typename FeatureT >

void pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::setSimilarityThreshold | ( | float | similarity_threshold | ) |

inline

Set the similarity threshold in [0,1[ between edge lengths of the underlying polygonal correspondence rejector object, where 1 is a perfect match.

Parameters

  similarity_threshold | edge length similarity threshold

Definition at line 202 of file sample_consensus_prerejective.h.

References pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::correspondence_rejector_poly_.

## setSourceFeatures()

template<typename PointSource , typename PointTarget , typename FeatureT >

void pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::setSourceFeatures | ( | const FeatureCloudConstPtr & | features | ) |

Provide a boost shared pointer to the source point cloud's feature descriptors.

Parameters

  features | the source point cloud's features

Definition at line 46 of file sample_consensus_prerejective.hpp.

Referenced by pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::~SampleConsensusPrerejective().

## setTargetFeatures()

template<typename PointSource , typename PointTarget , typename FeatureT >

void pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::setTargetFeatures | ( | const FeatureCloudConstPtr & | features | ) |

Provide a boost shared pointer to the target point cloud's feature descriptors.

Parameters

  features | the target point cloud's features

Definition at line 58 of file sample_consensus_prerejective.hpp.

Referenced by pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getSourceFeatures().

## Member Data Documentation

## correspondence_rejector_poly_

template<typename PointSource , typename PointTarget , typename FeatureT >

CorrespondenceRejectorPolyPtr pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::correspondence_rejector_poly_

protected

The polygonal correspondence rejector used for prerejection.

Definition at line 308 of file sample_consensus_prerejective.h.

Referenced by pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getSimilarityThreshold(), pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::SampleConsensusPrerejective(), and pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::setSimilarityThreshold().

## feature_tree_

template<typename PointSource , typename PointTarget , typename FeatureT >

FeatureKdTreePtr pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::feature_tree_

protected

The KdTree used to compare feature descriptors.

Definition at line 305 of file sample_consensus_prerejective.h.

## inlier_fraction_

template<typename PointSource , typename PointTarget , typename FeatureT >

float pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::inlier_fraction_

protected

The fraction [0,1] of inlier points required for accepting a transformation.

Definition at line 311 of file sample_consensus_prerejective.h.

Referenced by pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getInlierFraction(), and pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::setInlierFraction().

## inliers_

template<typename PointSource , typename PointTarget , typename FeatureT >

std::vector<int> pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::inliers_

protected

Inlier points of final transformation as indices into source.

Definition at line 314 of file sample_consensus_prerejective.h.

Referenced by pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getInliers().

## input_features_

template<typename PointSource , typename PointTarget , typename FeatureT >

FeatureCloudConstPtr pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::input_features_

protected

The source point cloud's feature descriptors.

Definition at line 293 of file sample_consensus_prerejective.h.

Referenced by pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getSourceFeatures().

## k_correspondences_

template<typename PointSource , typename PointTarget , typename FeatureT >

int pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::k_correspondences_

protected

The number of neighbors to use when selecting a random feature correspondence.

Definition at line 302 of file sample_consensus_prerejective.h.

Referenced by pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getCorrespondenceRandomness(), and pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::setCorrespondenceRandomness().

## nr_samples_

template<typename PointSource , typename PointTarget , typename FeatureT >

int pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::nr_samples_

protected

The number of samples to use during each iteration.

Definition at line 299 of file sample_consensus_prerejective.h.

Referenced by pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getNumberOfSamples(), and pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::setNumberOfSamples().

## target_features_

template<typename PointSource , typename PointTarget , typename FeatureT >

FeatureCloudConstPtr pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::target_features_

protected

The target point cloud's feature descriptors.

Definition at line 296 of file sample_consensus_prerejective.h.

Referenced by pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getTargetFeatures().

The documentation for this class was generated from the following files:

- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/registration/include/pcl/registration/sample_consensus_prerejective.h
- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/registration/include/pcl/registration/impl/sample_consensus_prerejective.hpp